* Import data: process_patents_appln_id.csv;
PROC IMPORT OUT= WORK.pp_appln_id 
            DATAFILE= "D:\Patstat\process_patents_appln_id.csv" 
            DBMS=CSV REPLACE;
     GETNAMES=YES;
     DATAROW=2; 
RUN;

* Merge pp_appln_id onto tls201_appln;
	* running time: 11:57.47;
	* 8,439,869 rows and 15 columns;
proc sql;
create table patstat.pp_tls201 as
SELECT 
tls201_appln.appln_id, tls201_appln.appln_auth, tls201_appln.appln_kind, tls201_appln.appln_filing_date,
	tls201_appln.appln_filing_year, tls201_appln.ipr_type,tls201_appln.receiving_office, 
	tls201_appln.earliest_filing_date, tls201_appln.earliest_filing_year, 
	tls201_appln.granted,tls201_appln.docdb_family_id, tls201_appln.docdb_family_size, tls201_appln.nb_citing_docdb_fam, 
	tls201_appln.nb_applicants, tls201_appln.nb_inventors
FROM patstat.tls201_appln
INNER JOIN work.pp_appln_id ON tls201_appln.appln_id = pp_appln_id.appln_id
WHERE tls201_appln.earliest_filing_year > 1999
ORDER by appln_id;
quit;

* Merge tls_207 onto pp_tls201; 
	* running time: 5:25.42;
	* 27,893,640 rows and 16 columns;
proc sql;
create table patstat2.pp_patstat as
SELECT 
pp_tls201.*,
tls207_pers_appln.person_id
FROM patstat.pp_tls201
LEFT JOIN patstat.tls207_pers_appln ON pp_tls201.appln_id = tls207_pers_appln.appln_id
ORDER by appln_id;
quit;

* Merge tls_206 onto pp_patstat; 
	* running time: 10:30.42;
	* 27,893,640 rows and 18 columns;
proc sql;
create table patstat2.pp_patstat as
SELECT 
pp_patstat.*,
tls206_person.person_ctry_code, tls206_person.psn_sector
FROM patstat2.pp_patstat
LEFT JOIN patstat.tls206_person ON pp_patstat.person_id = tls206_person.person_id
ORDER by appln_id;
quit;

* Merge tls_211 onto pp_patstat; 
	* running time:  9:19.33;
	* 46,854,808 rows and 25 columns;
proc sql;
create table patstat2.pp_patstat as
SELECT 
pp_patstat.*,
tls211_pat_publn.pat_publn_id, tls211_pat_publn.publn_auth, tls211_pat_publn.publn_kind,
	tls211_pat_publn.publn_claims, tls211_pat_publn.publn_date, 
	tls211_pat_publn.publn_first_grant, tls211_pat_publn.publn_nr
FROM patstat2.pp_patstat
LEFT JOIN patstat.tls211_pat_publn ON pp_patstat.appln_id = tls211_pat_publn.appln_id
ORDER by appln_id;
quit;


* Merge tls_801 onto pp_patstat; 
	* running time:14:13.18;
	* 46,854,808 rows and 33 column;

proc sql;
create table patstat2.pp_patstat as
SELECT 
pp_patstat.*,
tls801_country.iso_alpha3, tls801_country.st3_name, tls801_country.organisation_flag, 
	tls801_country.continent, tls801_country.eu_member, tls801_country.epo_member, 
	tls801_country.oecd_member, tls801_country.discontinued
FROM patstat2.pp_patstat
LEFT JOIN patstat.tls801_country ON pp_patstat.person_ctry_code = tls801_country.ctry_code
ORDER by appln_id;
quit;

* Merge tls_225 onto pp_patstat; 
	* 46854808 rows and 33 column;

	* identify Y02P patents;
		*running time: 1:14.75;
		* 623,827 rows and 2 columns;
		proc sql;
		create table work.cpc_Y02P as
		SELECT DISTINCT
		tls225_docdb_fam_cpc.docdb_family_id, tls225_docdb_fam_cpc.cpc_class_symbol
		FROM patstat.tls225_docdb_fam_cpc
		WHERE substr(tls225_docdb_fam_cpc.cpc_class_symbol, 1, 4)= "Y02P";
		quit;
		* create variable with Y02P;
			* 584,294 rows and 2 columns;
		proc sql;
		create table patstat2.cpc_Y02P_dummy as
		SELECT DISTINCT
		cpc_Y02P.docdb_family_id, substr(cpc_Y02P.cpc_class_symbol, 1, 4) AS Y02P
		FROM work.cpc_Y02P;
		quit;
		* create variable with Y02PN;
			* 594,111 rows and 2 columns;
		proc sql;
		create table patstat2.cpc_Y02Pn as
		SELECT DISTINCT
		cpc_Y02P.docdb_family_id, substr(cpc_Y02P.cpc_class_symbol, 1, 7) AS Y02PN
		FROM work.cpc_Y02P;
		quit;

	* identify Y02 patents;
		*running time: 1:07.61;
		* 3,873,114 rows and 2 columns;
		proc sql;
		create table patstat2.cpc_Y02 as
		SELECT DISTINCT
		tls225_docdb_fam_cpc.docdb_family_id, tls225_docdb_fam_cpc.cpc_class_symbol
		FROM patstat.tls225_docdb_fam_cpc
		WHERE substr(tls225_docdb_fam_cpc.cpc_class_symbol, 1, 3)= "Y02";
		quit;
		* create variable with Y02;
			* 3,072,717 rows and 2 columns;
		proc sql;
		create table patstat2.cpc_Y02_dummy as
		SELECT DISTINCT
		cpc_Y02.docdb_family_id, substr(cpc_Y02.cpc_class_symbol, 1, 3) AS Y02
		FROM patstat2.cpc_Y02;
		quit;


		* count unique docdb_family_id
			* 584,294 unique Y02P docdb_family_id in tls225;
			proc sql;
			SELECT COUNT(DISTINCT cpc_Y02P_dummy.docdb_family_id)
			FROM patstat2.cpc_Y02P_dummy;
			quit;
			* 3,072,717 unique Y02 docdb_family_id in tls225;
			proc sql;
			SELECT COUNT(DISTINCT cpc_Y02_dummy.docdb_family_id)
			FROM patstat2.cpc_Y02_dummy;
			quit;
			* 6,002,421 unique docdb_family_id in pp_patstat;
			proc sql;
			SELECT COUNT(DISTINCT pp_patstat.docdb_family_id)
			FROM patstat2.pp_patstat;
			quit;
			* unique docdb_family_id in tls225_docdb_fam_cpc;
				* how many docdb_family_ids have cpc code??
			*proc sql;
			*SELECT COUNT(DISTINCT tls225_docdb_fam_cpc.docdb_family_id)
			*FROM patstat.tls225_docdb_fam_cpc;
			*quit;
			* unique docdb_family_id in pp_patstat (all years);
				* 12,117,484 (from process_patents_epo.txt and process_patents_uspto.txt)
			* unique appln_id in pp_patstat (all years);
				* 15,683,232 (from process_patents_appln_id.csv)
			* unique appln_id in pp_tls201 (earliest_filing_year > 1999);
				* 8,439,869 (from row numbers in pp_tls201) 
			* unique appln_id in patstat;
				* 108,754,877 from row numbers in tls201_appln
					* seems too little though(?) 

	* Merge cpc_y02_dummy onto pp_patstat; 
		* running time: 14:09.55;
		* 46,854,808 rows and 34 columns;
	proc sql;
	create table patstat2.pp_patstat as
	SELECT 
	pp_patstat.*,
	cpc_y02_dummy.y02
	FROM patstat2.pp_patstat
	LEFT JOIN patstat2.cpc_y02_dummy ON pp_patstat.docdb_family_id = cpc_y02_dummy.docdb_family_id;
	quit;

	* Merge cpc_y02pn onto pp_patstat; 
		* running time: 4:13.10;
		* 46,883,116 rows and 35 columns;
	proc sql;
	create table patstat2.pp_patstat as
	SELECT 
	pp_patstat.*,
	cpc_y02pn.y02pn
	FROM patstat2.pp_patstat
	LEFT JOIN patstat2.cpc_y02pn ON pp_patstat.docdb_family_id = cpc_y02pn.docdb_family_id;
	quit;

* Merge tls229_appln_nace2 onto pp_patstat;
	* running time: 22:00.00;
	* 73,473,097 rows and 37 columns;

proc sql;
create table patstat2.pp_patstat as
SELECT 
pp_patstat.*,
tls229_appln_nace2.nace2_code, tls229_appln_nace2.weight
FROM patstat2.pp_patstat
LEFT JOIN patstat.tls229_appln_nace2 ON pp_patstat.appln_id = tls229_appln_nace2.appln_id
ORDER by appln_id;
quit;





